// CylinderPointDist.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <gp_Pnt.hxx>
#include <gp_Dir.hxx>
#include <gp_Ax3.hxx>
#include <gp_Cylinder.hxx>
#include <ElSLib.hxx>

#include <Geom_Surface.hxx>
#include <Geom_CylindricalSurface.hxx>
#include <GeomAPI_ProjectPointOnSurf.hxx>

#include <iostream>
using std::cout;
using std::endl;

double CylDist(const gp_Cylinder& cyl, const gp_Pnt& pnt)
{
	double u, v;
	ElSLib::Parameters(cyl, pnt, u, v);
	return pnt.Distance(ElSLib::Value(u, v, cyl));
}

double CylDist(const Handle(Geom_Surface)& cyl, const gp_Pnt& pnt)
{
	GeomAPI_ProjectPointOnSurf PPS(pnt, cyl);
	return PPS.LowerDistance();
}


int _tmain(int argc, _TCHAR* argv[])
{
	gp_Ax3 ax(gp_Pnt(0,0,0), gp_Dir(0,0,1));
	gp_Cylinder cyl(ax, 100);

	gp_Pnt P(110, 0, 0);

	Handle(Geom_CylindricalSurface) aSurf = new Geom_CylindricalSurface(cyl);
	double dist = CylDist(cyl, P);
	cout << "Distance is " << dist << endl;
	return 0;
}

